Subject: Re: [PATCH v4 08/23] ewah: compressed bitmap implementation

From: Jonathan Nieder <[email-masked]>
Date: Thu, 23 Jan 2014 14:17:55 -0800

Jeff King wrote:
> On Thu, Jan 23, 2014 at 09:53:26PM +0000, brian m. carlson wrote:

>> Yes, it will.  SPARC requires all loads be naturally aligned (4-byte to
>> an address that's a multiple of 4, 8-byte to a multiple of 8, and so
>> on).  In general, architectures that do not support unaligned access
>> require natural alignment for all quantities.
>
> In that case, I think we cannot even blame Shawn. The ewah serialization
> format itself (which JGit inherited from the javaewah library) has 8
> bytes of header and 4 bytes of trailer. So packed serialized ewahs
> wouldn't be 8-byte aligned

I don't think that's a big issue.  A pair of 4-byte reads would not be
too slow.

Even on x86, aligned reads are supposed to be faster than unaligned
reads (though I haven't looked at benchmarks recently).